/*
BeginILUCopyright

Copyright (c) 1991-1998 Xerox Corporation.  All Rights Reserved.

Unlimited use, reproduction, modification, and distribution of this
software and modified versions thereof is permitted.  Permission is
granted to make derivative works from this software or a modified
version thereof.  Any copy of this software, a modified version
thereof, or a derivative work must include both the above copyright
notice of Xerox Corporation and this paragraph.  Any distribution of
this software, a modified version thereof, or a derivative work must
comply with all applicable United States export control laws.  This
software is made available AS IS, and XEROX CORPORATION DISCLAIMS ALL
WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE, AND NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY
LIABILITY FOR DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS
EXPRESSLY DISCLAIMED, WHETHER ARISING IN CONTRACT, TORT (INCLUDING
NEGLIGENCE) OR STRICT LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED
OF THE POSSIBILITY OF SUCH DAMAGES.
  
EndILUCopyright

$Id: ilugss_conf.h,v 1.3 1998/10/08 22:39:48 janssen Exp $
*/
/* This default ilugss_conf.h is configured for normal UNIX
 * workstations with 32-bit integers, and a Big-Endian architecture;
 * OR for Windows 32 machines with 32-bit ints, and Little-Endian
 * architecture.
 */

#ifndef	_ILUGSS_CONF_H_
#define	_ILUGSS_CONF_H_

#ifdef WIN32

/* Define if your processor stores words with the most significant
   byte first (like Motorola and SPARC, unlike Intel and VAX).
   Some security mechanisms need to have this information to
   do marshalling properly. */
#ifdef WORDS_BIGENDIAN
#undef WORDS_BIGENDIAN
#endif

/* figure the sizes of char, short, int, and long */
#define SIZEOF_CHAR 1
#define SIZEOF_SHORT 2
#define SIZEOF_INT 4
#define SIZEOF_LONG 4

#else	/* not WIN32 */

/* Define if your processor stores words with the most significant
   byte first (like Motorola and SPARC, unlike Intel and VAX).
   Some security mechanisms need to have this information to
   do marshalling properly. */
#define WORDS_BIGENDIAN 1

/* figure the sizes of char, short, int, and long */
#define SIZEOF_CHAR 1
#define SIZEOF_SHORT 2
#define SIZEOF_INT 4
#define SIZEOF_LONG 4

#endif	/* def WIN32 */

#endif	/* _ILUGSS_CONF_H_ */
